<?php
/************************************************************/
/* NPDS : Net Portal Dynamic System 
=============================================================
module : maintenance
Description: Permet de mettre Npds en mode mainteance pour faire vos 
mise a jour.
Auteur: Johan VIVIEN
Date de creation: 24 mai 2008
Version: 0.3 Beta
Auteur URI: http://www.hotfirenet.com
Copyright (c) 2002-2008 par Johan VIVIEN
=============================================================
This program is free software. You can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation; either version 2 of the License.       
/************************************************************/

#Autodoc Hotfirenet >> Assure la securit d'administration de Npds
if (!eregi("admin.php", $PHP_SELF)) { die(); }
if (strstr($ModPath,"..") || strstr($ModStart,"..") || stristr($ModPath, "script") || stristr($ModPath, "cookie") || stristr($ModPath, "iframe") || stristr($ModPath, "applet") || stristr($ModPath, "object") || stristr($ModPath, "meta") || stristr($ModStart, "script") || stristr($ModStart, "cookie") || stristr($ModStart, "iframe") || stristr($ModStart, "applet") || stristr($ModStart, "object") || stristr($ModStart, "meta")) {
   die();
}
	
	$admin_url = 'admin.php?op=Extend-Admin-SubModule&ModPath='.$ModPath.'&ModStart='.$ModStart;
	$maintenanceVersion = '0.3 Beta';

	function heurefin($deb_hour,$deb_min,$deb_sec) 
	{
		global $gmt;

		$day = 1;
		if ($deb_hour!=-1 and $deb_min!=-1 and $deb_sec!=-1) 
		{
			$html = '<select class="textbox_standard" name="deb_hour">';
			
			$hour = 0;
			while ($hour <= 23) 
			{
				if ($hour < 10) 
					$hour = '0'.$hour.'';
				
				if ($deb_hour==$hour) 
				{
					$sel= 'selected';
				} 
				else
				{
					$sel= '';
				}
				
				$html .= '<option name="deb_hour" '.$sel.'>'.$hour.'</option>';
				$hour++;
			}
			
			$html .= '</select>';
			$html .= '&nbsp;<select class="textbox_standard" name="deb_min">';
			
			$min = 0;
			while ($min <= 59) 
			{
				if ($min < 10)
					$min = '0'.$min.'';

				if ($deb_min==$min) 
				{
					$sel='selected';
				} else {
					$sel='';
				}
				
				$html .= '<option name="deb_min" '.$sel.'>'.$min.'</option>';
				$min++;
			}
			$html .= '</select>';
			$html .= '&nbsp;<select class="textbox_standard" name="deb_sec">';
			
			$sec = 0;
			while ($sec <= 59) 
			{
				if ($sec < 10) 
					$sec = '0'.$sec.'';
				
				if ($deb_sec==$sec) 
				{
					$sel='selected';
				} else 
				{
					$sel='';
				}
				
				$html .= '<option name="deb_sec" '.$sel.'>'.$sec.'</option>';
				$sec++;
			}
			$html .= '</select>';
		}
		
		return $html;
	}
	
	function modiFichier($fichier, $content)
	{
		if (file_exists($fichier)) 
		{
			if (is_writable($fichier)) 
			{
				if (!$handle = fopen($fichier, 'w')) 
				{
					$erreur = admMaintenanceTranslate('Impossible d&#183;ouvrir le fichier ('.$fichier.')');
					exit;
				}
				if (fwrite($handle, $content) === FALSE) 
				{
					$erreur = admMaintenanceTranslate('Impossible d&#183;crire dans le fichier ('.$fichier.')');
					exit;
				}

				$erreur = admMaintenanceTranslate('L&#183;criture dans le fichier ('.$fichier.') a russi');

				fclose($handle);
			} 
			else 
			{ 
				$erreur = admMaintenanceTranslate('Le fichier '.$fichier.' n&#183;est pas accessible en criture.'); 
			}
		} 
		else 
		{ 
			$erreur = admMaintenanceTranslate('Le fichier '.$fichier." n&#183;existe pas !");
		}
		
		return $erreur;
	}
	
	function updateConfigMaintenance($datefin, $deb_hour, $deb_min, $deb_sec, $activer, $xRaison)
	{
		global $maintenanceVersion, $ModPath;
		
		list($jour,$mois,$annee) = explode('/',$datefin);
		$timestamp = mktime($deb_hour,$deb_min,$deb_sec,$mois,$jour,$annee);

		$configMaintenance = "<?php\n";
		$configMaintenance .= "/************************************************************/\n";
		$configMaintenance .= "/* NPDS : Net Portal Dynamic System \n";
		$configMaintenance . "==============================================================\n";
		$configMaintenance .= "module : maintenance\n";
		$configMaintenance .= "Description: Permet de mettre Npds en mode mainteance pour faire vos \n";
		$configMaintenance .= "mise a jour.\n";
		$configMaintenance .= "Auteur: Johan VIVIEN\n";
		$configMaintenance .= "Date de creation: 24 mai 2008\n";
		$configMaintenance .= "Version: ".$maintenanceVersion."\n";
		$configMaintenance .= "Auteur URI: http://www.hotfirenet.com\n";
		$configMaintenance .= "Copyright (c) 2002-2008 par Johan VIVIEN\n";
		$configMaintenance .= "==============================================================\n";
		$configMaintenance .= "This program is free software. You can redistribute it and/or modify \n";
		$configMaintenance .= "it under the terms of the GNU General Public License as published by \n";
		$configMaintenance .= "the Free Software Foundation; either version 2 of the License.       \n";
		$configMaintenance .= "/************************************************************/\n";
		$configMaintenance .= "\$maintenance = ".$activer.";\n";
		$configMaintenance .= "\$end = ".$timestamp.";\n";
		$configMaintenance .= "\$raison = '".$xRaison."';\n";
		$configMaintenance .= "?>\n";	
		
		$resultat = modiFichier('modules/'.$ModPath.'/include/maintenance.conf.php',$configMaintenance);	
		
		return $resultat;
	}

	function createMaintenanceTheme($action) 
	{
		if ($action = 'create') 
		{
			mkdir ('/themes/'.$Default_Theme.'/html/modules/maintenance', 0777);
			mkdir ('/themes/'.$Default_Theme.'/html/modules/maintenance/images', 0777);
			copy('modules/maintenance/theme/index.html','themes/'.$Default_Theme.'/html/modules/maintenance/index.html');
			copy('modules/maintenance/theme/maintenance.html','themes/'.$Default_Theme.'/html/modules/maintenance/maintenance.html');
			chmod('themes/'.$Default_Theme.'/html/modules/maintenance/maintenance.html',0766);
			
			// @unlink('modules/hot-travaux/admin/include/travaux.inc');
		} 
		elseif ($action == 'chmod') 
		{
			@chmod('modules/hot-travaux/travaux.html',0766);
		}
	}

	function infos() 
	{
		global $Default_Theme;
		$img_check = '<img src="modules/maintenance/admin/images/check_%s.png" alt="" />';

		$file = 'modules/maintenance/';
		if(is_dir($file)) 
		{
			if (is_writable(dirname($file))) 
			{
				$erreur = sprintf($img_check,'on').' '.sprintf(admMaintenanceTranslate('Le repertoire %s est accessible en criture.'),$file).'<br /><br />';
			} 
			else 
			{ 
				$erreur = sprintf($img_check,'off').' '.sprintf(admMaintenanceTranslate('Le repertoire %s n&#183;est pas accessible en criture.'),$file).'<br /><br />'; 
			} 
		}
		else 
		{ 
			$erreur = sprintf($img_check,'off').' '.sprintf(admMaintenanceTranslate('Le repertoire %s n&#183;existe pas.'),$file).'<br /><br />'; 
		}


		$file = 'modules/maintenance/admin/include/';
		if(is_dir($file)) 
		{
			if (is_writable(dirname($file))) 
			{
				$erreur .= sprintf($img_check,'on').' '.sprintf(admMaintenanceTranslate('Le repertoire %s est accessible en criture.'),$file).'<br /><br />';
			} 
			else 
			{ 
				$erreur .= sprintf($img_check,'off').' '.sprintf(admMaintenanceTranslate('Le repertoire %s n&#183;est pas accessible en criture.'),$file).'<br /><br />'; 
			} 
		}
		else 
		{ 
			$erreur .= sprintf($img_check,'off').' '.sprintf(admMaintenanceTranslate('Le repertoire %s n&#183;existe pas.'),$file).'<br /><br />'; 
		}
		
		$file = 'themes/'.$Default_Theme.'/html/modules/maintenance/maintenance.html';
		if(file_exists($file)) 
		{
			if (is_writable(dirname($file))) 
			{
				$erreur .= sprintf($img_check,'on').' '.sprintf(admMaintenanceTranslate('Le fichier %s est accessible en criture.'),$file).'<br /><br />';
			} 
			else 
			{ 
				$erreur .= sprintf($img_check,'off').' '.sprintf(admMaintenanceTranslate('Le fichier %s n&#183;est pas accessible en criture.'),$file).'<br /><br />'; 
			} 
		}
		elseif(file_exists('themes/default/html/modules/maintenance/maintenance.html'))
		{			
			$erreur .= sprintf($img_check,'off').' '.sprintf(admMaintenanceTranslate('Le fichier %s n&#183;existe pas.'),$file).'<br /><br />';
		
			$file1 = 'themes/default/html/modules/maintenance/maintenance.html';
			if (is_writable(dirname($file1))) 
			{
				$erreur .= sprintf($img_check,'on').' '.sprintf(admMaintenanceTranslate('Le fichier %s est accessible en criture.'),$file1).'<br /><br />';
			} 
			else 
			{ 
				$erreur .= sprintf($img_check,'off').' '.sprintf(admMaintenanceTranslate('Le fichier %s n&#183;est pas accessible en criture.'),$file1).'<br /><br />'; 
			} 	
		}
		else 
		{ 
			$erreur .= sprintf($img_check,'off').' '.sprintf(admMaintenanceTranslate('Le fichier %s n&#183;existe pas.'),$file).'<br /><br />'; 
		}
		
		$file = 'modules/maintenance/install.conf.php';
		if(file_exists($file)) 
		{
			$erreur .= sprintf($img_check,'off').' '.sprintf(admMaintenanceTranslate('Veuillez supprimer %s.'),$file).'<br /><br />';
		}
		
		if (!empty($erreur)) 
			echo $erreur; 
	}

	function top($titre_operation) {
	 global $hot_travaux_version, $language, $NPDS_Prefix, $admin_url;

	   opentable();
	    echo '<div class="HEADER" align="center">'.admMaintenanceTranslate('Administration de').' Maintenance   '.$titre_operation.'</div><br />'
	       . '<center><a href="'.$admin_url.'">'.admMaintenanceTranslate('Configurer').' Maintenance</a> | <a href="'.$admin_url.'&subop=config_html">'.admMaintenanceTranslate('Configurer la page de maintenance').'</a> | <a href="'.$admin_url.'&subop=aide">'.admMaintenanceTranslate('Aide').'</a> | <a href="'.$admin_url.'&subop=info">'.admMaintenanceTranslate('Infos').'</a></center>';
	       //. "<SCRIPT LANGUAGE="javascript" SRC="http://www.hotfirenet.com/modules/maj/maj.php?module=hot-travaux&version='.$hot_travaux_version.'&language='.$language.'" type="text/javascript"></SCRIPT>\n&#183;;
	   closetable();
	    echo '<br />';
	   opentable();
	}

	function copyright() 
	{
		global $maintenanceVersion;

		closetable();
		
		echo '<br />';
		
		opentable();
		
		echo '<center>'.admMaintenanceTranslate('Module Ralis par').' <a href="http://www.hotfirenet.com" target="blank">Hotfirenet</a> '.admMaintenanceTranslate('pour').' <a href="http://www.npds.org" target="blank">Npds</a>'
		. '<br />Maintenance V.'.$maintenanceVersion.'</center>';
		
		closetable();
	}
	
?>
