<?php
/************************************************************/
/* NPDS : Net Portal Dynamic System 
=============================================================
module : maintenance
Description: Permet de mettre Npds en mode mainteance pour faire vos 
mise a jour.
Auteur: Johan VIVIEN
Date de creation: 24 mai 2008
Version: 0.3 Beta
Auteur URI: http://www.hotfirenet.com
Copyright (c) 2002-2008 par Johan VIVIEN
=============================================================
This program is free software. You can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation; either version 2 of the License.       
/************************************************************/

function fabDate($letimestamp)
{
	$date = date ('d/m/Y H:i:s' , $letimestamp); 

	$prefix = "Le ";
	$suffix = " ";
	$tab_month = array(1=>"Janvier", "Fevrier", "Mars", "Avril", "Mai", "Juin", "Juillet", "Aout", "Septembre", "Octobre", "Novembre", "Decembre");
	$tab_day = array("Dimanche", "Lundi", "Mardi", "Mercredi", "Jeudi", "Vendredi", "Samedi");
	$tab_date = explode(' ', $date);
	$date_hour = explode(':', $tab_date[1]);
	$tab_dmy = explode('-', $tab_date[0]);
	$day = date("w", mktime(0, 0, 0, $tab_dmy[1], $tab_dmy[2], $tab_dmy[0]));
	$date = $prefix . "$tab_day[$day] " . "$tab_dmy[2] ";
	settype($tab_dmy[1], integer);
	$date .= $tab_month[$tab_dmy[1]] . " $tab_dmy[0]" . $suffix . " $date_hour[0]h " . "$date_hour[1]min";

	return $date;
}

function hot_meta_lang($hot_content, $raison, $date_indispo)
{
	#Autodoc Hotfirenet >>  Intgration des globals
	global $Titlesitename, $sitename, $nuke_url, $Default_Theme;
	
	#Autodoc Hotfirenet >> Mis en place des meta
	$hot_content=ereg_replace('!:doctype:!',doctype,$hot_content);
	$hot_content=ereg_replace('!:cur_charset:!',cur_charset,$hot_content);	
	
	#Autodoc Hotfirenet >> Differentes variables
	$hot_content=ereg_replace('!:Titlesitename:!',$Titlesitename,$hot_content);
	$hot_content=ereg_replace('!:sitename:!',$sitename,$hot_content);	
	$hot_content=ereg_replace('!:urlsite:!',$nuke_url,$hot_content);	
	$hot_content=ereg_replace('!:date_indispo:!', fabDate($date_indispo),$hot_content);
	$hot_content=ereg_replace('!:raison:!',$raison,$hot_content);
	
	#Autodoc Hotfirenet >> systeme d'adresse mail anti-spam repris dans npds
	$deb=strpos($hot_content,"!:contact:!",0)+11;
	$fin=strpos($hot_content," ",$deb);
	if ($fin) {
		$H_as=substr($hot_content,$deb,$fin-$deb);
	} else {
		$H_as=substr($hot_content,$deb);
	}
	$mail_anti_spam="<a href=\"mailto:".anti_spam($H_as)."\" target=\"_blank\">".str_replace("@","_at_",$H_as)."</a>";
	$hot_content=ereg_replace('!:contact:!'.$H_as,$mail_anti_spam,$hot_content);
	
	#Autodoc Hotfirenet >> box de login admin
	$boxstaff = translate("Administration Tools");
	$boxstaff .= "<form action=\"admin.php\" method=\"post\" name=\"adminlogin\">\n";
	$boxstaff .= "<font size=1><center>".translate("Nickname")."<br>\n";
	$boxstaff .= "<input class=\"TEXTBOX_STANDARD\" type=\"text\" name=\"aid\" size=\"20\" maxlength=\"20\"><br />\n";
	$boxstaff .= "".translate("Password")."<br>\n";
	$boxstaff .= "<input class=\"TEXTBOX_STANDARD\" type=\"password\" name=\"pwd\" size=\"20\" maxlength=\"18\"><br />\n";
	$boxstaff .= "<input type=\"hidden\" name=\"op\" value=\"login\"><br />\n";
	$boxstaff .= "<input class=\"BOUTON_STANDARD\" type=\"submit\" value=\"".translate("Submit")."\"></form>\n";
	$boxstaff .= "<script type=\"text/javascript\" language=\"JavaScript\">document.adminlogin.aid.focus();</script>\n";
	
	$hot_content=ereg_replace("!:boxstaff:!",$boxstaff,$hot_content);
	
	#Autodoc Hotfirenet >> Image de maintenance et Est ce que l'image de maintenance existe ??
	if (file_exists('themes/'.$Default_Theme.'/html/modules/maintenance/images/maintenance.png')) 
	{		
		$img_maintenance = '<img src="themes/'.$Default_Theme.'/html/modules/maintenance/images/maintenance.png" />';
	}
	elseif(file_exists('themes/default/html/modules/maintenance/images/maintenance.png')) 
	{
		$img_maintenance = '<img src="themes/default/html/modules/maintenance/images/maintenance.png" />';
	}
	else
	{
		echo "maintenance.png manquant / not find !<br />";
	}	

	$hot_content=ereg_replace('!:img_maintenance:!',$img_maintenance,$hot_content);	
	
	return $hot_content;
}

function activeInfo()
{
	global $admin, $end, $maintenance;
	
	echo $maintenance;
	
	// if(file_exists('modules/maintenance/include/maintenance.conf.php')) { include_once 'modules/maintenance/include/maintenance.conf.php'; }
	
	if($maintenance && $admin)
		echo '<div class="rouge">Attention le module de maintenance est activ jusqu\'a '.fabDate($end).'</div>';
}
?>