<?php
/************************************************************/
/* NPDS : Net Portal Dynamic System 
=============================================================
module : maintenance
Description: Permet de mettre Npds en mode mainteance pour faire vos 
mise a jour.
Auteur: Johan VIVIEN
Date de creation: 24 mai 2008
Version: 0.3 Beta
Auteur URI: http://www.hotfirenet.com
Copyright (c) 2002-2008 par Johan VIVIEN
=============================================================
This program is free software. You can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation; either version 2 of the License.       
/************************************************************/

#Autodoc Hotfirenet >> Assure la securit d'administration de Npds
if (!eregi("admin.php", $PHP_SELF)) { die(); }
if (strstr($ModPath,"..") || strstr($ModStart,"..") || stristr($ModPath, "script") || stristr($ModPath, "cookie") || stristr($ModPath, "iframe") || stristr($ModPath, "applet") || stristr($ModPath, "object") || stristr($ModPath, "meta") || stristr($ModStart, "script") || stristr($ModStart, "cookie") || stristr($ModStart, "iframe") || stristr($ModStart, "applet") || stristr($ModStart, "object") || stristr($ModStart, "meta")) {
   die();
}

global $language, $ModPath, $ModStart, $NPDS_Prefix, $pdst, $admin, $gmt, $tiny_mce, $Default_Theme;

if(file_exists('modules/'.$ModPath.'/admin/language/adm_'.$language.'.php')) { include_once 'modules/'.$ModPath.'/admin/language/adm_'.$language.'.php'; } else { echo 'probleme de langue '.$language.' module maintenance'; }
if(file_exists('modules/'.$ModPath.'/admin/include/admFonctions.php')) { include_once 'modules/'.$ModPath.'/admin/include/admFonctions.php'; } else { echo 'probleme de fonction module maintenance'; }
if(file_exists('modules/'.$ModPath.'/include/maintenance.conf.php')) { include_once 'modules/'.$ModPath.'/include/maintenance.conf.php'; } else { echo 'probleme de config module maintenance'; }


	if($admin) 
	{
		switch($subop) 
		{
			case 'config_html' :
				$titre_operation = admMaintenanceTranslate('Configurer la page de maintenance');
				top($titre_operation);
				include ('modules/'.$ModPath.'/admin/include/configHtml.php');
				break;

			case 'aide' :
				$titre_operation = admMaintenanceTranslate('Aide');
				top($titre_operation);
				include ('modules/'.$ModPath.'/admin/include/aide.php');
				break;

			case 'info' :
				$titre_operation = admMaintenanceTranslate('Infos');
				top($titre_operation);
				infos();
				break;
				
			case 'update':
				switch($action) 
				{					
					case 'configMaintenance':
						$resultat = updateConfigMaintenance($datefin, $deb_hour, $deb_min, $deb_sec, $activer, $xRaison);
						break;
						
					case 'configHtml':
						$resultat = modiFichier($fichier, $xHtml);	
						break;
				}
				
				$titre_operation = admMaintenanceTranslate('Mise  jour');				
				top($titre_operation);
				echo '<script type="text/javascript">window.setTimeout("location=(\''.$admin_url.'\');",5000)</script>';
				echo '<div id="message">
					'.$resultat.'
				</div>';
				break;

			default:
				$titre_operation = admMaintenanceTranslate('Configurer le module');
				top($titre_operation);
				include ('modules/'.$ModPath.'/admin/include/configMaintenance.php');
				break;  
		}
		
		copyright();

	} 
	else 
	{ 
		header ('Location: index.php');
		exit(); 
	}
?>