<?php
/************************************************************/
/* NPDS : Net Portal Dynamic System 
=============================================================
module : maintenance
Description: Permet de mettre Npds en mode mainteance pour faire vos 
mise a jour.
Auteur: Johan VIVIEN
Date de creation: 24 mai 2008
Version: 0.3 Beta
Auteur URI: http://www.hotfirenet.com
Copyright (c) 2002-2008 par Johan VIVIEN
=============================================================
This program is free software. You can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation; either version 2 of the License.       
/************************************************************/

function admMaintenanceTranslate($phrase) {
    switch ($phrase) 
	{
		#Autodoc >> Hotfirenet >> Traduction de admMaintenance.php
		case "Configurer la page de maintenance": $tmp = "To configure the page of work"; break;
		case "Aide": $tmp = "Help"; break;
		case "Infos": $tmp = "Info"; break;
		case "Mise  jour": $tmp = "Update"; break;
		case "Configurer le module": $tmp = "Set the module"; break;
		
		#Autodoc >> Hotfirenet >> Traduction de form/confightml.html		
		case "Modifier la page de maintenance :": $tmp = "Amend page maintenance:"; break;
		
		#Autodoc >> Hotfirenet >> Traduction de  form/configMaintenance.html		
		case "Configurer la date de fin de maintenance": $tmp = "Setting the date of completion of maintenance"; break;
		case "Configurer l&#183;heure de fin de travaux": $tmp = "Setting the time of completion of work"; break;
		case "Activer le module": $tmp = "Activate module"; break;
		case "La raison de la maintenance": $tmp = "The reason for maintenance"; break;
		
		#Autodoc >> Hotfirenet >> Traduction de include/admFonctions.php		
		#Autodoc >> Hotfirenet >> Traduction de 		
		case "Impossible d&#183;ouvrir le fichier ('.$fichier.')": $tmp = "Unable to open the file ('.$fichier.')"; break;
		case "Impossible d&#183;crire dans le fichier ('.$fichier.')": $tmp = "Unable d write to the file ('.$fichier.')"; break;
		case "L&#183;criture dans le fichier ('.$fichier.') a russi": $tmp = "Writing in the file ('.$fichier.') has succeeded"; break;
		
		#Autodoc >> Hotfirenet >> Traduction de 
		case "Le fichier $fichier n&#183;est pas accessible en criture.": $tmp = "The file $fichier is not available in writing."; break;
		case "Le fichier $fichier n&#183;existe pas !": $tmp = "The file $fichier not exist!"; break;
		case "Le fichier %s n&#183;existe pas.": $tmp = "The file %s not exist."; break;
		case "Le fichier %s est accessible en criture.": $tmp = "The file %s is available in writing."; break;		
		case "Le repertoire %s est accessible en criture.": $tmp = "The directory is available %s writing."; break;
		case "Le repertoire %s n&#183;est pas accessible en criture.": $tmp = "The directory %s is not available in writing."; break;
		case "Le repertoire %s n&#183;existe pas.": $tmp = "The directory %s not exist."; break;
		case "Veuillez supprimer %s.": $tmp = "Please delete %s."; break;

		#Autodoc >> Hotfirenet >> Traduction de top()		
		case "Administration de": $tmp = "Administration of"; break;
		case "Configurer": $tmp = "To configure"; break;
		
		#Autodoc >> Hotfirenet >> Traduction de copyright()
		case "Module Ralis par": $tmp = "Modulate created by"; break;
		case "pour": $tmp = "for"; break;	
		
		#Autodoc >> Hotfirenet >> Traduction de include/aide.php
		case "Ce module permet de mettre son site en travaux ou en maintenance automatiquement": $tmp = "This module makes it possible to put its site in work or maintenance automatically"; break;
		case "En activant le module depuis l&#183;administration, votre site affichera  automatiquement une page de travaux ou de maintenance qui contiendra le pourquoi, la date de  fin et un compte &agrave; rebours dynamique qui fera la redirection  automatiquement sur votre page d&#183;accueil &agrave; la fin de la dur&eacute;e des  travaux ou de la maintenance": $tmp = "By activating the module since the administration, your site will automatically post a page of work or maintenance which will contain it why, the completion date and a dynamic countdown which will automatically make the redirection on your banner page at the end of the duration of the work or maintenance"; break;
		case "Personalisation de la page travaux": $tmp = "Personalisation of the work page"; break;
		case "Toujours via l&#183;administration et si Tiny-Mce est activ&eacute; vous pourrez directement en ligne cr&eacute;er votre page de travaux ou de maintenace, le module g&eacute;n&eacute;re un fichier &quot;travaux.html&quot; et utilise un syst&egrave;me de M&eacute;ta Mots ind&eacute;pendant de Npds": $tmp = "Always via the administration and if Tiny-Mce is activated you will be able directly on line to create your page of work or maintenace, the module gnre a file \"travaux.html\" and uses a system of Mta Mots independent of Npds"; break;
		case "Voici la liste des M&eacute;ta Mots du module Hot-Travaux": $tmp = "Here the list of Mta Words of the module Hot-Work"; break;
		case "Bloc administrateur pour vous logguez en administrateur et acc&eacute;der au site et a l&#183;administration du site": $tmp = "Block administrator for you logguez as an administrator and to reach the site and has the administration of the site"; break;
		case "Affiche la date et l&#183;heure d&#183;indisponnibilit&eacute;e de votre site": $tmp = "Post the date and the hour of indisponnibilite of your site"; break;
		case "S&#183;utilise !:contact:!votreadresse@votreprovider.com, evite le spam et d&eacute;compose l&#183;adresse": $tmp = "Be used!:contact:!votreadresse@votreprovider.com, avoids the Spam and breaks up the address"; break;
		case "Affiche l&#183;image Maintenance": $tmp = "Post the Maintenance image"; break;
		case "pour tester le module il faut que vous ne soyez pas logguer ni en administrateur ni en utilisateur": $tmp = "to test the module it is necessary that you are logguer neither as an administrator nor as a user"; break;
				
		//       case "Administration de": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		//       case "": $tmp = ""; break;
		
		default: $tmp = "Translation error [** $phrase **]"; break;
	}
	
	if (cur_charset=="utf-8") 
	{
		return utf8_encode($tmp);
	} 
	else 
	{
		return ($tmp);
	}
} 

?>
