<?php
/************************************************************/
/* NPDS : Net Portal Dynamic System 
=============================================================
module : maintenance
Description: Permet de mettre Npds en mode mainteance pour faire vos 
mise a jour.
Auteur: Johan VIVIEN
Date de creation: 24 mai 2008
Version: 0.3 Beta
Auteur URI: http://www.hotfirenet.com
Copyright (c) 2002-2008 par Johan VIVIEN
=============================================================
This program is free software. You can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation; either version 2 of the License.       
/************************************************************/
#Autodoc Hotfirenet >>  Intgration des globals
global $admin, $Titlesitename, $Default_Theme;

#Autodoc Hotfirenet >>  Intgration des fichiers de config, de fonctions et de langue
	if(file_exists('modules/maintenance/include/maintenance.conf.php')) { include_once 'modules/maintenance/include/maintenance.conf.php'; } else { echo 'erreur fichier de conf'; }
	if(file_exists('modules/maintenance/include/fonctions.php')) { include_once 'modules/maintenance/include/fonctions.php'; } else { echo 'erreur fichier de conf'; }
	// if(file_exists('modules/maintenance/lang/'.$language)) { include_once 'modules/maintenance/lang/'.$language; } else { echo 'erreur fichier de lang'; }	
	
	#Autodoc Hotfirenet >> On donne  la variable la valeur de time()
	$now = time();

	#Autodoc Hotfirenet >> On Verifie si on est admin, si la maintenance est activ et si le timestamp actuel est bien inferieur a celui que l'on a defini
	if((!$admin) && ($maintenance) && ($now < $end))
	{
		#Autodoc Hotfirenet >> Est ce que le theme de maintenance existe ??
		if (file_exists('themes/'.$Default_Theme.'/html/modules/maintenance/maintenance.html')) 
		{		
			$incluTheme = 'themes/'.$Default_Theme.'/html/modules/maintenance/maintenance.html';
		}
		elseif(file_exists('themes/default/html/modules/maintenance/maintenance.html')) 
		{
			$incluTheme = 'themes/default/html/modules/maintenance/maintenance.html';
		}
		else
		{
			echo "maintenance.html manquant / not find !<br />";
		}
		
		#Autodoc Hotfirenet >> Si le theme existe
		if($incluTheme)
		{
			ob_start();		
				include_once $incluTheme;
				$hot_content = ob_get_contents();				
			ob_end_clean();
				
				echo hot_meta_lang($hot_content, $raison, $end);		
		}
		
		exit;
	}
?>